package searcher;

import hanabisetting.HanabiSettings;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

public class Searcher {

	/*
	 * NG[Aނ󂯎肻ꂼ̌AʂԂ
	 */
	public ArrayList<String> search(String query, String type) {

		// L[p
		final String KEY = HanabiSettings.TYPE_KEY;

		// Op
		final String NAME = HanabiSettings.TYPE_HUMAN;

		// ╪쌟p
		final String FIELD = HanabiSettings.TYPE_FIELD;

		// L[
		if (type.equals(KEY)) {
			ArrayList<String> nameList = getNameList(query);
			return nameList;
		}

		// O
		if (type.equals(NAME)) {
			ArrayList<String> nameList = getNameList(query);
			return nameList;
		}

		// 啪
		if (type.equals(FIELD)) {
			ArrayList<String> fieldList = getFieldList(query);
			return fieldList;
		}
		return null;
	}

	/*
	 * ÕXgԂ
	 */
	private ArrayList<String> getNameList(String query) {

		final String YAHOO_API = HanabiSettings.YAHOO_API;
		final String WEB_SEARCH = HanabiSettings.WEB_SEARCH;
		final String INIT_APPID = HanabiSettings.INIT_APPID;
		final String YAHOO_ID = HanabiSettings.YAHOO_ID;
		final String INIT_QUERY = HanabiSettings.INIT_QUERY;
		final String INIT_RESULTS_AMOUNT = HanabiSettings.INIT_RESULTS_AMOUNT;
		final int RESULTS = HanabiSettings.RESULTS;
		final String INIT_DOMAIN = HanabiSettings.INIT_DOMAIN;
		final String DOMAIN = HanabiSettings.DOMAIN;
		final String REVISION_WORD = HanabiSettings.REVISION_WORD;
		final int ARRAY_LENGTH = HanabiSettings.SEARCH_NUMBER_OF_TIMES;
		final int TIME_OUT = 100000;

		NameHandler handler;
		try {
			SAXParserFactory factory = SAXParserFactory.newInstance();
			SAXParser parser = factory.newSAXParser();
			handler = new NameHandler();
			String requestURL = new String();
			String request = URLEncoder.encode(query, "UTF-8");
			requestURL = YAHOO_API + WEB_SEARCH + INIT_APPID + YAHOO_ID
					+ INIT_QUERY + request + REVISION_WORD + INIT_RESULTS_AMOUNT
					+ RESULTS + INIT_DOMAIN + DOMAIN;
			URLConnection urlCon = new URL(requestURL).openConnection();
			urlCon.setConnectTimeout(TIME_OUT);
			try{
				parser.parse(requestURL, handler);
				ArrayList<String> nameList = new ArrayList<String>();
				ArrayList<TeacherCount> teacherCountList = handler.getTeacherCount();
				for (int i = 0; i < teacherCountList.size(); i++) {
					if (i > ARRAY_LENGTH - 1) {
						break;
					}
					nameList.add(teacherCountList.get(i).getName());
				}
				for(int i = 0; i < nameList.size(); i++){
					System.out.println(nameList.get(i));
				}
				return nameList;
			}
			catch(IOException e){
				System.out.println("XML Error");
				return null;
			}
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/*
	 * 啪Ԃ
	 */
	ArrayList<String> getFieldList(String query) {
		// g̐΃pX擾
		String path = HanabiSettings.DATA_DIR;

		final String XML_SOURCE = path + "faculty_sfc2.xml";

		final int ARRAY_LENGTH = 4;

		try {
			File xml = new File(XML_SOURCE);
			if(!xml.exists()){
				System.out.println("XML File Not Found");
				return null;
			}
			else if(!xml.canRead()){
				System.out.println("XML File Cannot Read");
				return null;
			}
			else{
				SAXParserFactory factory = SAXParserFactory.newInstance();
				SAXParser parser = factory.newSAXParser();
				FacultyHandler handler = new FacultyHandler();
				handler.setQuery(query);
				parser.parse(new FileInputStream(XML_SOURCE), handler);

				return arrayReduction(handler.getFieldList(), ARRAY_LENGTH);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	private ArrayList<String> arrayReduction(ArrayList<String> list,
			int arrayLength) {
		ArrayList<String> tempList = new ArrayList<String>();
		
		if(list == null){
			
		}
		else{
			for (int i = 0; i < list.size(); i++) {
				if (i > arrayLength - 1) {
					break;
				}
				tempList.add(list.get(i));
			}
		}
		return tempList;
	}
}
